//This program reads in a 24-bit bmp image file named test.tns in the directory bmpviewer

#include <os.h>
#include "utils.h"

asm(".string \"PRG\"\n");

int main(void) 
{
  //bitmap header
  char* header = (char*) malloc(0x36);
  //screen buffer
  char* scrbuf = (char*) malloc(SCREEN_BYTES_SIZE);
  clearBuf(scrbuf);
  //image file
  FILE* img;
  //loop indices
  int i, x, y;
  //read the header
  img = fopen("/documents/bmpviewer/test.tns", "rb");
  fread(header, 1, 0x36, img);
  //compute some ints (image data size, width, and height) from the header
  int bmpsize = header[34] + 
                256 * header[35] + 
                65536 * header[36] + 
                65536 * 256 * header[37]; 
  int w = header[18] + 
          256 * header[19] + 
          65536 * header[20] + 
          65536 * 256 * header[21]; 
  int h = header[22] + 
          256 * header[23] + 
          65536 * header[24] + 
          65536 * 256 * header[25]; 
  //number of pixels
  int pxsize = bmpsize / 3;
  //allocate byte data and pixel (grayscale) data
  char* data = (char*) malloc(bmpsize);
  char* pxdata = (char*) malloc(pxsize);
  //read in data and close image
  fread(data, 1, bmpsize, img);
  fclose(img);
  //convert RGB to grayscale
  for (i = 0; i < pxsize; i++) {
    pxdata[i] = (data[3 * i] + data[3 * i + 1] + data[3 * i + 2]) / 48;
  }
  //draw to the buffer and display it
  for (x = 0; x < w; x++) {
    for (y = 0; y < h; y++) {
      setPixelBuf(scrbuf, x, h - 1 - y, pxdata[w * y + x]);
    }
  }
  refresh(scrbuf);
  while (!isKeyPressed(KEY_NSPIRE_ESC)); 
  return 0;
}
